# Forkawesome survey

This post presents the results of a survey I ran for about 4 months, from the 17th of December 2022 until the 5th of April 2023. It was advertised on [mastodon](https://mastodon.xyz/@forkawesome@floss.social/109524151669247963), [twitter](https://twitter.com/forkawesome/status/1604147911008587776) and as a [github issue](https://github.com/ForkAwesome/Fork-Awesome/issues/408). Thanks to the 28 respondents and to the [CryptPad](https://cryptpad.fr/) crew for running their E2EE tools.

Here are graphs of the results with a short written summary after each:

![](img/1_use.png)

Most respondents (22, 78%) had used Forkawesome. Most (18, 64%) were currently using Forkawesome.

![](img/2_implement.png)

Implementing icons through icon font was by far the most preferred method (19, 67%). All the SVG methods combined didn't even get half as many preferences (7, 25%). 

I'm curious what other methods people are using... presumably using raster images with `<img>` or similar? I wish I had given that option.

![](img/3_perceive.png)

"Ease of font icon use" and "licensing" were perceived only positively. "style of icons", "ease of cross-platform use" and "number/coverage of icons" were perceived mostly positively. "Ease of SVG use" and "governance/management of project" had mixed perceptions. "Frequency of releases" was perceived mostly negatively.

Non-responses, that is "no opinion" and unanswered, were highest for "ease of SVG use". This corresponds with the previous question suggesting less SVG use.

![](img/4_compare.png)

With the exception of Fontawesome, most questions received non-responses. I take this to mean unfamiliarity with the other icons sets. Only "{your favorite}" and "ionicons" had overall positive responses, and even those were mixed. 

I find these results a bit difficult to interpret, but it at least suggests that for the respondents, there was no clearly superior icon set.

![](img/5_best.png)

The final question, in which respondents could select as many of the options as they wished. Most respondents (18, 64%) would like to see the project reactivated. Significant minorities (heck, everyone is a significant minority in a group of 28!) voted for the remaining options: to focus on SVG usage (8, 28%), to continue as before (7, 25%) and to encourage users elsewhere (4, 14%)

---

I've tried to keep my opinions out of the analysis as much as possible. An anonymized version of the raw results data can be found in this folder as a .csv 

I'm planning to write another post with my thoughts on this project soon: about licensing, technical aspects and relevance in 2023 onwards. For now it's safe to say that I'm open to other people getting involved and that I'm not planning to do significant technical work on Forkawesome any time soon.

Thanks for reading!
